<?php

namespace jrosset\Collections;

/**
 * Implementation for unique collection
 *
 * @psalm-template     TKey of array-key
 * @template-covariant TValue
 * @template-extends ImmutableCollection<TKey, TValue>
 */
trait TUniqueValues {
    /**
     * @inheritDoc
     */
    protected function _set (int|string $key, mixed $value): self {
        if ($this->contains($value)) {
            return $this;
        }

        $this->elements[$this->_normalizeKey($key)] = $value;
        return $this;
    }
    /**
     * @inheritDoc
     */
    protected function _add (mixed ...$values): self {
        foreach ($values as $value) {
            if ($this->contains($value)) {
                continue;
            }
            $this->elements[] = $value;
        }
        return $this;
    }
}